#include <stdio.h>
#include <math.h>
#include "SAM.h"

int main(void)
{      
	SAM_init(-1);
	mp_st<100> d,x1,x2;
	mp_st<100> a,b,c,half, four;

        sam_set_str(a, "0.3");
        sam_set_str(b, "-2.1");
        sam_set_str(c, "3.675");
        sam_set_str(half, "0.5");
	four=4;

	printf("----------------------------------\n");
	printf("|  Second order equation         |\n");
	printf("|  with SAM                      |\n");
	printf("----------------------------------\n");
	
	//
	//      CASE: A = 0
	//
	if (a==0)
		if (b==0) {
			if (c==0) printf("Every complex value is solution.\n");
			else printf("There is no solution.\n");
		}
		else {
			x1 = - c/b;
			printf("The equation is degenerated.\n");
			printf("There is one real solution %s\n",strp(x1));
		}
		else {
			//
			//     CASE: A /= 0
			//
			b = b/a;
			c = c/a;
			d = b*b - four*c;
			printf("d = %s\n",strp(d));
			//
			//   DISCRIMINANT = 0
			//
			if (d==0) {
				x1 = -b*half;
				printf("Discriminant is zero.\n");
				printf("The double solution is %s\n",strp(x1));
			}
			else {
				//
				//      DISCRIMINANT > 0
				//
				if (d>0.) {
					x1 = ( - b - sqrt(d))*half;
					x2 = ( - b + sqrt(d))*half;
					printf("There are two real solutions.\n");
					printf("x1 = %s x2 = %s\n",strp(x1),strp(x2));
				}
				else {
					//
					//      DISCRIMINANT < 0
					//
					x1 = - b*half;
					x2 = sqrt(-d)*half;
					printf("There are two complex solutions.\n");
					printf("z1 = %s  +  i * %s\n",strp(x1),strp(x2));
					printf("z2 = %s  +  i * %s\n",strp(x1), strp(-x2));
				}
			}
		}
	
	SAM_end();
	return 0;
}
