#include <iostream>
#include "SAM.h"

using namespace std;


int main(void)
{
	SAM_init(-1);
	mp_st<100> amat[11][11];
	int i,j,k;
	mp_st<100> aux, det;
	cout << "--------------------------------------------------------" << endl;
	cout << "|  Computation of the determinant of Hilbert's matrix  |" << endl; 
	cout << "|  using Gaussian elimination with SAM                 |" << endl;
	cout << "--------------------------------------------------------" << endl;

	for(i=1;i<=11;i++){
		for(j=1;j<=11;j++){
		  amat[i-1][j-1] = mp_st<100>(1)/mp_st<100>(i+j-1);
		}
	}
	det = mp_st<100>(1);	
	for(i=0;i<10;i++){
		cout << "Pivot number " << i << " = " << amat[i][i] << endl;
		det = det*amat[i][i];
		aux = mp_st<100>(1)/amat[i][i];
		for(j=i+1;j<11;j++)
			amat[i][j] = amat[i][j]*aux;
		
		for(j=i+1;j<11;j++){
			aux = amat[j][i];
			for(k=i+1;k<11;k++)
				amat[j][k] = amat[j][k] - aux*amat[i][k];
		}
	}
	cout << "Pivot number " << i << " = "  << amat[i][i] << endl;
	det = det*amat[i][i];
	cout << "Determinant      = " << det << endl;
	
	SAM_end();
	return 0;
}
