#include "SAM.h"
#include <math.h>
#include <stdio.h>

int main(void)
{
    SAM_init(-1);
    mp_st<100> y, x, t[6], half, exact_root;
    int i, nmax=100;
    printf("-------------------------------------------------------------\n");
    printf("|  Computation of a root of a polynomial by Newton's method |\n");
    printf("|  with SAM                                                 |\n");
    printf("-------------------------------------------------------------\n");
    sam_set_str(half,"0.5");
    sam_set_str(t[0],"1.47");
    sam_set_str(t[1],"1.19");
    sam_set_str(t[2],"-1.83");
    sam_set_str(t[3],"0.45");
    sam_set_str(t[4],"4.41");
    sam_set_str(t[5],"2.38");
    //if an integer is assigned to an mp_st, no perturbation is performed.
    exact_root=3;
    exact_root/=7;

    y = half;
    for(i = 1;i<=nmax;i++){
       x = y;
       y=x-((t[0]*x*x*x+t[1]*x*x+t[2]*x+t[3])/(t[4]*x*x+t[5]*x+t[2]));
       if (x==y) break;
    }
    
    printf("x(%3d)     = %s\n",i-1,strp(x));
    printf("x(%3d)     = %s\n",i,strp(y));
    printf("exact root = %s\n",strp(exact_root));
    
    SAM_end();
    return 0;
}
