#include "SAM.h"
#include <math.h>
#include <stdio.h>

int main(void)
{
    SAM_init(-1);
    mp_st<100> y, x, exact_root;
    int i, nmax=100;
    printf("-------------------------------------------------------------\n");
    printf("|  Computation of a root of a polynomial by Newton's method |\n");
    printf("|  with SAM                                                 |\n");
    printf("-------------------------------------------------------------\n");
    exact_root=3;
    exact_root/=7;
    
    y = 0.5;
    for(i = 1;i<=nmax;i++){
       x = y;
   //  The polynomial coefficients are double values
   //  only their 15 first digits are correct.
       y = x-(1.47*x*x*x+1.19*x*x-1.83*x+0.45) / (4.41*x*x+2.38*x-1.83); 
       if (x==y) break;
    }
    
    printf("x(%3d)     = %s\n",i-1,strp(x));
    printf("x(%3d)     = %s\n",i,strp(y));
    printf("exact root = %s\n",strp(exact_root));

    SAM_end();
    return 0;
}
