#include "stdio.h"
#include <math.h>
#include "SAM.h"

#define IDIM 4


int main(void)
{
    SAM_init(-1);
    mp_st<53> tt;
    
    mp_st<53> a[IDIM][IDIM+1]={
			       
			       {sam_set_str(tt,"21"), sam_set_str(tt,"130"),   0,                           sam_set_str(tt,"2.1"),     sam_set_str(tt,"153.1")},
			       {sam_set_str(tt,"13"), sam_set_str(tt,"80"),    sam_set_str(tt,"4.74e+8"),   sam_set_str(tt,"752"),     sam_set_str(tt,"849.74")},
			       {0,                    sam_set_str(tt,"-0.4"),  sam_set_str(tt,"3.9816e+8"), sam_set_str(tt,"4.2"),     sam_set_str(tt,"7.7816")},
			       {0,                    0,                       sam_set_str(tt,"1.7"),       sam_set_str(tt,"9.0e-9"),  sam_set_str(tt,"2.6e-8")}};
    mp_st<53>  xsol[IDIM]={1, 1, sam_set_str(tt,"1.e-8"),1};
    
    
    printf("------------------------------------------------------\n");
    printf("| Solving a linear system using Gaussian elimination |\n");
    printf("| with partial pivoting                              |\n");
    printf("------------------------------------------------------\n");
    
    int i,j,k,ll;
    mp_st<53> pmax, aux;
    ll = -1; // the compiler cant prove that this will be initialised before use
    for(i=0; i<IDIM-1;i++){
	
	pmax = 0.0;
	
	for(j=i; j<IDIM;j++){
	    if(fabs(a[j][i])>pmax){
		pmax = fabs(a[j][i]);		
		ll = j;
	    }
	}
	if (ll!=i) {
	    for(j=i; j<IDIM+1;j++){ 
		aux = a[i][j];
		a[i][j] = a[ll][j];
		a[ll][j] = aux;
	    }
	}
	aux = 1/a[i][i];
	for(j=i+1; j<IDIM+1;j++)
	    a[i][j] = a[i][j]*aux;
	
	for (k=i+1;k<IDIM;k++){
	    aux = a[k][i];
	    for(j=i+1;j<IDIM+1;j++)
		a[k][j]=a[k][j] - aux*a[i][j];
	}
    }
    
    a[IDIM-1][IDIM] = a[IDIM-1][IDIM]/a[IDIM-1][IDIM-1];
    
    for(i=IDIM-2;i>=0;i--)
	for(j=i+1;j<IDIM;j++)
	    a[i][IDIM] = a[i][IDIM] - a[i][j]*a[j][IDIM];
    
    for( i=0;i<IDIM;i++)
	printf("x_sol(%d) = %s (exact solution: xsol(%d)= %s)\n",
	       i,strp(a[i][IDIM]),i,strp(xsol[i]));
    
    SAM_end();
    return 0;
}
